Attribute VB_Name = "mdErrors"
'
'Copyright (C) 2003-2006 Funambol
'
'This program is free software; you can redistribute it and/or modify
'it under the terms of the GNU General Public License as published by
'the Free Software Foundation; either version 2 of the License, or
'(at your option) any later version.
'
'This program is distributed in the hope that it will be useful,
'but WITHOUT ANY WARRANTY; without even the implied warranty of
'MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'GNU General Public License for more details.
'
'You should have received a copy of the GNU General Public License
'along with this program; if not, write to the Free Software
'Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
'

'****************************************************************
'*Module:  mdErrors.bas                                   *
'*Author:  Valeria Olivati - c/o Funambol - Pavia - Italy       *
'*                                                              *
'*This module contains the fixErrors function used for          *
'*controlling all the possible errors that can occur into the   *
'*project.                                                      *
'****************************************************************

Option Explicit

Public Function fixErrors(ByRef ErrorNumber As Integer) As Integer
    'used for collecting all the errors in one function
    'in order to handle them togheter
    'Response values are:
    '0 for Exit
    '1 for Resume
    '2 for Resume Next
        
Dim response As Integer
Dim message As String

Select Case ErrorNumber
'errors for arrays
Case 6 'Overflow error
    'MsgBox "Internal error. Please restart Application", vbCritical
    logToDebug "Internal error. Please restart Application"
    message = Err.Description
    fixErrors = 6
    'mdUnload.closeProgram
    
Case 7 'Out of memory error
    message = "You have too many files open. Please close any unnecessary files and retry"
    ' Display message box for Retry/Cancel the program
    response = MsgBox(message, vbRetryCancel + vbCritical)
    If response = vbCancel Then
        mdUnload.closeProgram
    ElseIf response = vbRetry Then
        fixErrors = 1 'resume
    End If
Case 9 'Subscript out of range
        fixErrors = 2 'resume next
'errors for files
Case 53 'File not found
    message = "The file was not found."
    message = message & Chr(13) & "Verify the requested files into the folder:"
    message = message & Chr(13) & CurDir
    message = message & Chr(13) & "before retrying."
    ' Display message box for Retry/Cancel the program
    response = MsgBox(message, vbRetryCancel + vbCritical)
    If response = vbCancel Then
        fixErrors = 0 'Exit
    ElseIf response = vbRetry Then
        fixErrors = 1 'resume
    End If
Case 54, 75 'Bad file mode, Path/File access error
    message = "The files you attempted to write to have read-only status."
    message = message & Chr(13) & "Check the files status into the folder:"
    message = message & Chr(13) & CurDir
    message = message & Chr(13) & "before retrying."
    ' Display message box for Retry/Cancel the program
    response = MsgBox(message, vbRetryCancel + vbCritical)
    If response = vbCancel Then
        fixErrors = 0 'Exit
    ElseIf response = vbRetry Then
        fixErrors = 1 'resume
    End If
Case 61 'Disk full
    message = "There is not enough available space on the disk."
    message = message & Chr(13) & "You have to free space on disk to complete the operation."
    ' Display message box for Retry/Cancel the program
    response = MsgBox(message, vbRetryCancel + vbCritical)
    If response = vbCancel Then
        fixErrors = 0 'Exit
    ElseIf response = vbRetry Then
        fixErrors = 1 'resume
    End If
Case 67 'Too many files
    message = "You have too many files open. Please close any unnecessary files and retry"
    ' Display message box for Retry/Cancel the program
    response = MsgBox(message, vbRetryCancel + vbCritical)
    If response = vbCancel Then
        mdUnload.closeProgram
    ElseIf response = vbRetry Then
        fixErrors = 1 'resume
    End If
Case 70 'Permission denied
    message = "You tried to open a write-protected file or"
    message = message & Chr(13) & "a file locked by another process."
    message = message & Chr(13) & "Check files status before retrying."
    ' Display message box for Retry/Cancel the program
    response = MsgBox(message, vbRetryCancel + vbCritical)
    If response = vbCancel Then
        fixErrors = 0 'Exit
    ElseIf response = vbRetry Then
        fixErrors = 1 'resume
    End If
Case 76 'Path not found
    message = "The path for the internal files was not found."
    message = message & Chr(13) & "Check the files and subfolders into folder:"
    message = message & Chr(13) & CurDir
    message = message & Chr(13) & "before retrying."
    ' Display message box for Retry/Cancel the program
    response = MsgBox(message, vbRetryCancel + vbCritical)
    If response = vbCancel Then
        fixErrors = 0 'Exit
    ElseIf response = vbRetry Then
        fixErrors = 1 'resume
    End If
Case 31001 'Out of memory
    message = "There is not enough memory or disk space."
    message = message & Chr(13) & "You have to free space on disk or close other programs to complete the operation."
    ' Display message box for Retry/Cancel the program
    response = MsgBox(message, vbRetryCancel + vbCritical)
    If response = vbCancel Then
        fixErrors = 0 'Exit
    ElseIf response = vbRetry Then
        fixErrors = 1 'resume
    End If
Case 31036 'Error saving to file
    message = "An error in saving to files occured."
    message = message & Chr(13) & "Check your disk free space and retry."
    ' Display message box for Retry/Cancel the program
    response = MsgBox(message, vbRetryCancel + vbCritical)
    If response = vbCancel Then
        fixErrors = 0 'Exit
    ElseIf response = vbRetry Then
        fixErrors = 1 'resume
    End If
Case 31037 'Error loading from file
    message = "An error in loading from files occured"
    message = message & Chr(13) & "Probably a corrupted file. Try to restore your data and restart the application."
    ' Display message box for Retry/Cancel the program
    response = MsgBox(message, vbOKOnly + vbCritical)
    If response = vbOK Then
        mdUnload.closeProgram
    End If
'errors for objects
Case 91 'Object variable or With block variable not set
    MsgBox "Error link with Outlook MAPI NameSpace or Object. Please restart Application", vbCritical
    mdUnload.closeProgram
Case 380 'Invalid property value
    MsgBox "Error on value for Object property. Please restart Application", vbCritical
    mdUnload.closeProgram
Case 429 'Runtime Error '429' : ActiveX Component Can't Create Object
    MsgBox "Error on property or method on Object. Please restart Application", vbCritical
    printLog "Cannot logon Outlook: check username/password", INFO_LEVEL
    mdUnload.closeProgram
Case 438 'Object doesn't support this property or method
    MsgBox "Error on property or method on Object. Please restart Application", vbCritical
    mdUnload.closeProgram
Case 31004 'no object
    MsgBox "Internal error on Object. Please restart Application", vbCritical
    mdUnload.closeProgram
'other errors
Case Else
    message = "Unexpected error #" & Str(Err.number)
    message = message & " occurred: " & Err.Description
    ' Display message box for Abort/Retry/Ignore the error
    response = MsgBox(message, vbAbortRetryIgnore + vbCritical)
    If response = vbAbort Then
        mdUnload.closeProgram
    ElseIf response = vbRetry Then
        fixErrors = 1 'resume
    ElseIf response = vbIgnore Then
        fixErrors = 2 'resume next
    End If
End Select

End Function
