Attribute VB_Name = "mdVariables"
'
'Copyright (C) 2003-2006 Funambol
'
'This program is free software; you can redistribute it and/or modify
'it under the terms of the GNU General Public License as published by
'the Free Software Foundation; either version 2 of the License, or
'(at your option) any later version.
'
'This program is distributed in the hope that it will be useful,
'but WITHOUT ANY WARRANTY; without even the implied warranty of
'MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'GNU General Public License for more details.
'
'You should have received a copy of the GNU General Public License
'along with this program; if not, write to the Free Software
'Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
'

'****************************************************************
'*Module:  mdVariables.bas                                      *
'*Author:  Valeria Olivati - c/o Funambol - Pavia - Italy       *
'*                                                              *
'*This module contains the definitions for all the public       *
'*objects, variables, constants, arrays and user-defined types  *
'*used in SyncML.                                               *
'*Also contains a function use for the Debug.Print method so    *
'*that it can be disabled easily if needed.                     *
'****************************************************************

Option Explicit

'************************
'*   Type definitions   *
'************************

'New type used for listing all the needed properties for the existent folders
Public Type FolderInfo
    EntryID As String
    name As String
    Selected As Boolean
    Changed As Boolean
    FolderLevel As Integer
    CompletePath As String
End Type

'new Type used for listing all the properties of an Item
Public Type ItemProperty
    PropID As Integer
    Property As String
    DataType As String
    name As String
    IsDefault As Boolean
    InCal As Boolean
    InCon As Boolean
    InMail As Boolean
    InTask As Boolean
    InNote As Boolean
End Type

'New type used for listing EntryID and Type of the selected folders in preferences
Public Type EntryAndType
    EntryID As String
    Type As Integer
End Type

'New type used for listing ID and Name of the selected Item Properties in preferences
Public Type ID_Name_Prop
    PropID As Integer
    name As String
    Property As String
End Type

'***********************************
'*   Public constants definition   *
'***********************************

'constants for the caption of GoTo button in frmPreferences form
Public Const CAP_SW_FOLDER As String = "&Switch to Folders Selection"
Public Const CAP_SW_ITEM_PROP As String = "&Switch to Items Properties Selection"

'constants for the caption of GoTo button in frmPreferences form
Public Const CAP_DEF_FOLDER As String = "&Reset to Default Selected Folders"
Public Const CAP_DEF_ITEM_PROP As String = "&Reset to Default Item Properties"

'constant for the EntryIDs of the folders selected for sync
Public Const NAME_PREFERENCES_FILE As String = "folders.preferences"
Public Const NAME_PROPERTIES_FILE As String = "items.preferences"
Public Const NAME_PROPERTIES_LIST_FILE As String = "list_for_properties.db"

'constants for the names of the files in which we save the items entryIDs to sync
Public Const NAME_ALL_FILE As String = "all_items.db"
Public Const NAME_DEL_FILE As String = "del_items.db"
Public Const NAME_CRE_FILE As String = "cre_items.db"
Public Const NAME_MOD_FILE As String = "mod_items.db"
Public Const NAME_OLD_FILE As String = "old_items.db"

Public Const LOGVB As String = "logVB.txt"

'constant for the name of the file used in frmActions for reading/writing
'the item properties names and values for the specified action in the form
Public Const NAME_ITEM_VALUES As String = "item_values.txt"

'constants to determine the type of folder
Public Const FOLDER_TYPE_CAL As Integer = 1
Public Const FOLDER_TYPE_CON As Integer = 2
Public Const FOLDER_TYPE_MAIL As Integer = 3
Public Const FOLDER_TYPE_TASK As Integer = 4
Public Const FOLDER_TYPE_NOTE As Integer = 5

'constants to determine the type of items of the file
Public Const FILE_TYPE_ALL As Integer = 0
Public Const FILE_TYPE_CRE As Integer = 1
Public Const FILE_TYPE_MOD As Integer = 2
Public Const FILE_TYPE_DEL As Integer = 3

'************************************
'*   Public variables declaration   *
'************************************

'to save the current Outlook MAPI NameSpace
Public nameSpace As Outlook.nameSpace

'counters for folders
Public publicCounter As Integer 'it is used for counting how many folders exists in the Default Folder for a type
Public publicRecounter As Integer 'it is the publicCounter used for saving the names of the folders in myArray() of readOLFolders
Public countSelected As Integer 'it is used for redim the array for selected folders EntryID

'to save if the file with preferences for folders and for item properties exist
Public prefExists As Boolean
Public propExists As Boolean

'to save if the file with Old Items exists
Public oldExists As Boolean

'to identify the level of subfolders when reading the Outlook folder structure
Public readFolderLevel As Integer

'to identify the full path of the item into the folder
Public readFolderPath As String

'arrays for listing all the existent folders and subfolders of the specified type
'and their EntryID, Name, if Selected, if Changed from last sync
Public calendarFolders() As FolderInfo
Public contactsFolders() As FolderInfo
Public mailFolders() As FolderInfo
Public tasksFolders() As FolderInfo
Public notesFolders() As FolderInfo

'array for selected folders EntryID, used for comboBox in frmForSync form
Public selectedFolders() As EntryAndType

'global list for all the item properties the user can choose
Public itemProperties() As ItemProperty

'list the IDs for properties to sync for each type of items
Public calendarProperties() As ID_Name_Prop
Public contactsProperties() As ID_Name_Prop
Public mailProperties() As ID_Name_Prop
Public tasksProperties() As ID_Name_Prop
Public notesProperties() As ID_Name_Prop

'to save the date of last sync for the folders
Public lastSync As Date

'to save the list of created items to compare with the modificated items
'in order to avoid duplications
Public createdList() As String
Public provaString() As String

'it contains the id of the item new, modified and deleted and the corrispondent folder name
Public createdListMM() As Variant
Public modifiedListMM() As Variant
Public deletedListMM() As Variant

Public dummyInitializingVariantArray() As Variant
'list of folder deleted by user and don't keep get by client. Used for deleting contacts subfolders
Public deletedFolders() As String
'array used to reset the deletedFolders()
Public dummyInitializingStringArray() As String

' Used to store wich source we are currently syncing.
' For callback functions, to retrieve which folder is under sync.
Public currentObjFolder As Integer
Public currentFolderType As Integer
Public currentFolders() As FolderInfo



'*******************************
'*   Routine for Debug.Print   *
'*******************************

Sub logToDebug(ByRef debugString As String)
'used for easily disable the Debug.Print in all the project

Debug.Print debugString

'Open mdVariables.LOGVB For Output As #1
'Print #1, debugString
'Close #1

End Sub

'**********************************
'*   Routine for Control MsgBox   *
'**********************************

Sub controlMsgBox(ByRef msgBoxString As String)
'used for easily disable the Debug.Print in all the project

MsgBox msgBoxString, vbOKOnly, "SyncClient Outlook"

End Sub

