/*
 * Copyright (C) 2003-2006 Funambol
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */


#include "outlook/winmaincpp.h"


typedef int (__stdcall *SetItemPtr)(void);

static BOOL dbg = false;
static BOOL dbg2 = false;
BSTR bstr;

static wchar_t programName[64];

USING_PTYPES



BOOL getFileList(wchar_t *dir, wchar_t** ptrArray, int *count, BOOL onlyFilesNumber) {

    WIN32_FIND_DATA FileData;
    wchar_t localTemp[256];
    HANDLE hFind;
    wchar_t toFind    [512];
    wchar_t szNewPath [512];
    wchar_t filterPattern [256];

    BOOL ret    = TRUE;
    szNewPath[0] =   0;
    int lung = 0;

    DWORD dwAttrs;
    BOOL fFinished = FALSE;

    wsprintf(filterPattern, TEXT("*.*"));

    wsprintf(toFind, TEXT("%s\\%s"), dir, filterPattern);

    if (dbg) {
        MessageBox (NULL, toFind, TEXT ("RetrieveFiles"), MB_SETFOREGROUND |MB_OK);
    }

    hFind = FindFirstFile(toFind, &FileData);

    int i = 0;

    if (hFind == INVALID_HANDLE_VALUE) {
        if (dbg)
		    MessageBox (NULL, TEXT("Invalid handle for retrieve files"), TEXT ("RetrieveFiles"), MB_SETFOREGROUND |MB_OK);
        return FALSE;
    }
    else {

        if (onlyFilesNumber)  {
            //only to retrieve number of files
	        while (!fFinished) {
                wsprintf(localTemp, TEXT("%s\\%s"), dir, FileData.cFileName);
                if (dbg) {
		            MessageBox (NULL, localTemp, TEXT ("RetrieveFiles"), MB_SETFOREGROUND |MB_OK);
                }
                dwAttrs = GetFileAttributes(localTemp);

                if (dwAttrs & FILE_ATTRIBUTE_DIRECTORY) {
                   // nothing
                } else if (dwAttrs & FILE_ATTRIBUTE_HIDDEN) {
                    // nothing
                } else if (dwAttrs & FILE_ATTRIBUTE_SYSTEM) {
                    // nothing
                } else {
                    i++;
                }
		        if (!FindNextFile(hFind, &FileData)) {
			        if (GetLastError() == ERROR_NO_MORE_FILES){
				        fFinished = TRUE;
			        } else {
				       // remain into loop
			        }
		        }
	        }
            if (dbg) {
                wsprintf(localTemp, TEXT("Numero di file %i"), i);
                MessageBox (NULL, localTemp, TEXT ("Totale number of files"), MB_SETFOREGROUND |MB_OK);
            }
            *count = i;
        }
        else {

            while (!fFinished) {
                wsprintf(szNewPath, TEXT("%s/%s"), dir, FileData.cFileName);
			    // wsprintf(szNewPath, TEXT("%s"), FileData.cFileName);
                dwAttrs = GetFileAttributes(szNewPath);

                 if (dwAttrs & FILE_ATTRIBUTE_DIRECTORY) {
                   // nothing
                } else if (dwAttrs & FILE_ATTRIBUTE_HIDDEN) {
                    // nothing
                } else if (dwAttrs & FILE_ATTRIBUTE_SYSTEM) {
                    // nothing
                } else {
                    ptrArray[i] = new wchar_t[256];
                    // wsprintf(ptrArray[i], szNewPath);
                    wsprintf(ptrArray[i], FileData.cFileName);

                    i++;
                }

                wsprintf(szNewPath, TEXT(""));

                if (!FindNextFile(hFind, &FileData)) {
				    if (GetLastError() == ERROR_NO_MORE_FILES){
					    fFinished = TRUE;
				    }
				    else {
					    // remain into loop
				    }
			    }
                *count = i;
		    }
        }
    // Close the search handle.

	FindClose(hFind);
    }
    return ret;

}




//------------------------- From Client to Server functions -----------------------------
/*
 * Get items from file system, from client to server. 
 * Get the dir name and file names for the type of array required (ALL | NEW | MOD),
 * then call the 'fillItemsArrayFromFileSystem' function to fill the appropriate array with all items.
 * Note: This function works on All, New or Updated Items. Deleted items are managed separatly, 
 *       calling function 'getDelItemsFromString' from WindowsSyncSource.
 *
 * @param c           : the container with arrays to fill
 * @param path        : the path where files are stored
 * @param sourceName  : the source to sync (contact | calendar | task | note)
 * @param typeOfArray : the type of Items to get (ALL | NEW | MOD)
 */
void getItemsFromFileSystem(Container* c, wchar_t* path, const wchar_t* sourceName, wchar_t* typeOfArray) {

    LOG.debug(T("Enter method getItemsFromFileSystem"));
    if (dbg) {
        MessageBox (NULL, TEXT("in getItemsFromFileSystem... "), TEXT ("Debug VC"), MB_SETFOREGROUND |MB_OK);
    }

    wchar_t localTemp[DIM_LOCAL_TEMP];
    wchar_t completePath[DIM_LOCAL_TEMP];
    wchar_t** ptrFileNames;					// Contains the names of files to retrieve
	wchar_t dirName [256];
	int itemNumber = -1;

    // Set the directory where files are stored.
	wmemset(dirName, 0, 255);
	if (wcscmp(typeOfArray, ALL) == 0){						// ALL Items (slow-sync)
		if (wcscmp(CONTACTS, sourceName) == 0)
			wsprintf(dirName, DIR_ALL_ITEM_CONTACTS);
		else if (wcscmp(APPOINTMENTS, sourceName) == 0)
			wsprintf(dirName, DIR_ALL_ITEM_CALENDARS);
		else if (wcscmp(TASKS, sourceName) == 0)
			wsprintf(dirName, DIR_ALL_ITEM_TASKS);
		else if (wcscmp(NOTES, sourceName) == 0)
			wsprintf(dirName, DIR_ALL_ITEM_NOTES);
	}
	else if (wcscmp(typeOfArray, NEW) == 0){				// NEW Items (fast-sync)
		if (wcscmp(CONTACTS, sourceName) == 0)
			wsprintf(dirName, DIR_NEW_ITEM_CONTACTS);
		else if (wcscmp(APPOINTMENTS, sourceName) == 0)
			wsprintf(dirName, DIR_NEW_ITEM_CALENDARS);
		else if (wcscmp(TASKS, sourceName) == 0)
			wsprintf(dirName, DIR_NEW_ITEM_TASKS);
		else if (wcscmp(NOTES, sourceName) == 0)
			wsprintf(dirName, DIR_NEW_ITEM_NOTES);
	}
	else if (wcscmp(typeOfArray, MOD) == 0){				// MOD Items (fast-sync)
		if (wcscmp(CONTACTS, sourceName) == 0)
			wsprintf(dirName, DIR_MOD_ITEM_CONTACTS);
		else if (wcscmp(APPOINTMENTS, sourceName) == 0)
			wsprintf(dirName, DIR_MOD_ITEM_CALENDARS);
		else if (wcscmp(TASKS, sourceName) == 0)
			wsprintf(dirName, DIR_MOD_ITEM_TASKS);
		else if (wcscmp(NOTES, sourceName) == 0)
			wsprintf(dirName, DIR_MOD_ITEM_NOTES);
	}
    else{
        // Error! (DEL items are not processed here).
    }


    wsprintf(completePath, TEXT("%s%s"), path, dirName);
    if (dbg) {
        MessageBox (NULL, completePath, TEXT ("Debug VC"), MB_SETFOREGROUND |MB_OK);
    }

	// get number of files in dir, get file names.
    getFileList(completePath, NULL, &itemNumber, TRUE);
    wsprintf(localTemp, TEXT("%i"), itemNumber);
    ptrFileNames = new wchar_t*[itemNumber];
    getFileList(completePath, ptrFileNames, &itemNumber, FALSE);
    wsprintf(localTemp, TEXT("%i"), itemNumber);

    if (dbg) {
        MessageBox (NULL, TEXT("After getFileList with complete... "), TEXT ("Debug VC"), MB_SETFOREGROUND |MB_OK);
    }

	// Reads all items from file system and fills the appropriate array in the Container 'c'.
	fillItemsArrayFromFileSystem(c, path, dirName, ptrFileNames, itemNumber, typeOfArray, sourceName);


    //Free mem.
    if (ptrFileNames != NULL){
        delete [] ptrFileNames; ptrFileNames = NULL;
    }
    LOG.debug(T("Exit method getItemsFromFileSystem"));
}




/*
 * Get deleted items from an xml string, fill the deletedItems array of the container 'c'.
 *
 * @param c   : the container with arrays to fill
 * @param xml : the xml string containing informations of deleted items (on client)
 * @return    : number of deleted items added
 */
int getDelItemsFromString (Container* c, wchar_t* xml) {

    LOG.debug(T("Enter method getDelItemsFromString"));
	SyncItem* syncItem = NULL;
	wchar_t localTemp[DIM_LOCAL_TEMP];
	wchar_t* element = NULL;
    wchar_t* tmp = NULL;
    wchar_t* id = NULL;
    

    // Get number of deleted items.
	int i = 0;
    unsigned int pos = 0;
    element = getElementContent(xml, TEXT("numItems"), &pos);

    if (element == NULL) {
        if (dbg) {
            wsprintf(localTemp, TEXT("getDelItemsFromString: numero di items %s"), element);
            MessageBox (NULL, localTemp, TEXT ("xmlDel"), MB_SETFOREGROUND |MB_OK);
        }
        LOG.debug(T("Exit method getDelItemsFromString: element numItems is NULL"));
        return 0;
    }
    int l = wcstol(element, &tmp, 0);

    if (dbg) {
        wsprintf(localTemp, TEXT("getDelItemsFromString: numero di items %i"), l);
        MessageBox (NULL, localTemp, TEXT ("xmlDel"), MB_SETFOREGROUND |MB_OK);
        wsprintf(localTemp, TEXT("lunghezza xml: %i"), wcslen(xml));
        MessageBox (NULL, localTemp, TEXT ("xmlDel"), MB_SETFOREGROUND |MB_OK);
        LOG.debug(T("%ls"), xml);
        MessageBox (NULL, xml, TEXT ("xmlDel"), MB_SETFOREGROUND |MB_OK);
    }

	// Cicle: search for deleted Items.
    LOG.debug(T("Method getDelItemsFromString: before cicle for."));
    for (i = 0; i < l; i++) {
        unsigned int tmpPos = 0;
        wchar_t forDbg[256];
        wsprintf(forDbg, TEXT("Method getDelItemsFromString: cicle for: number to-> %i, current index->%i "), l, i);
        LOG.debug(T("%ls"), forDbg);
        
		// Get the 'id' of the current item.
		element = getElementContent(&xml[pos], TEXT("row"), &tmpPos);
        pos = tmpPos + pos;
        id = getElementContent(element, TEXT("identifier"), NULL);
		
		
        // Insert the current item into the container.
		syncItem = new SyncItem(id);
		c->addItemToDeletedItems(syncItem);
        delete syncItem; syncItem = NULL;

    }
    LOG.debug(T("Method getDelItemsFromString: end cicle for"));

	// Free mem.
    if (element != NULL){
		delete [] element; element = NULL;
    }
    if (id != NULL){
		delete [] id; id = NULL;
    }
    LOG.debug(T("Exit Method getDelItemsFromString"));

    return l;
}

/*
 * Fill the Items Array of the container 'c' with items from file system.
 * (used for ALL | NEW | MOD items).
 *
 * @param c           : the container with arrays to fill
 * @param path        : the path where files are stored
 * @param dirName     : the directory name (allItemContacts | newItemContacts | allItemTasks ...)
 * @param ptrArray    : the array containing the name of files to read
 * @param itemNumber  : the number of items to retreive
 * @param typeOfArray : the type of Items to get (ALL | NEW | MOD)
 * @param sourceName  : the source to sync (contact | calendar | task | note)
 */
void fillItemsArrayFromFileSystem(Container* c, wchar_t* path, wchar_t* dirName, 
								  wchar_t** ptrArray, int itemNumber, wchar_t* typeOfArray, const wchar_t* sourceName) {

    SyncItem* syncItem = NULL;
    wchar_t localTemp[512];
    unsigned int tmpPos;
    wchar_t* fileContent;
    wchar_t completePath [512];

    LOG.debug(T("Enter method fillItemsArrayFromFileSystem"));
    wsprintf(localTemp, TEXT("fillItemsArrayFromFileSystem"));
    if (dbg) {
        MessageBox (NULL, localTemp, TEXT ("Debug VC"), MB_SETFOREGROUND |MB_OK);
    }

    bool useSIF = checkSIF(sourceName);

	// Every item:
    for (int i = 0; i < itemNumber; i++) {

        tmpPos = 0;
        fileContent = NULL;
        wsprintf(completePath, TEXT("%s%s\\%s"), path, dirName, ptrArray[i]);

        if (dbg) {
            MessageBox (NULL, path, TEXT ("Debug VC"), MB_SETFOREGROUND |MB_OK);
            MessageBox (NULL, ptrArray[i], TEXT ("Debug VC"), MB_SETFOREGROUND |MB_OK);
            MessageBox (NULL, completePath, TEXT ("Debug VC"), MB_SETFOREGROUND |MB_OK);
        }

        syncItem = new SyncItem(ptrArray[i]);
		
		// Read from file system
        fileContent = readContentFromFile(completePath);

        if (dbg) {
            MessageBox (NULL, fileContent, TEXT ("Debug VC"), MB_SETFOREGROUND |MB_OK);
        }

        if (fileContent != NULL) {
            char* charData = NULL;
            //LOG.debug("Filling item %d:", i+1);
            //LOG.debug("%ls", fileContent);

			// VB actually returns XML SIF from outlook. 
			// Source 'notes' is always used in SIF format.
			//
			// ------------ SIF format --------------
			// directly pass the SIF string
			if(useSIF || wcscmp(NOTES, sourceName) == 0){

                // Now API works with char data
                charData = wchar2char(fileContent);
			}

			// ----------- Vcard - Ical -------------
			// (SIF XML -> VObject -> Vcard XML)
			else{
				VObject* vo;
                wchar_t* wData = NULL;

				// Convert back "&amp; to "&", &lt; to "<", &gt; to ">"
				// (by now use SIF from VB to dll...)
				string xmlString = fileContent;
				replaceAmpLGt(xmlString);
				
				if (wcscmp(CONTACTS, sourceName) == 0)		        // contact
					vo = SIF2VObjectContact(xmlString);

				else if (wcscmp(APPOINTMENTS, sourceName) == 0) 	// calendar
					vo = SIF2VObjectAppointment(xmlString);

				else if (wcscmp(TASKS, sourceName) == 0) 	        // tasks
					vo = SIF2VObjectTask(xmlString);

				else{
					LOG.debug(T("Error converting SIF to VCARD: unknown folder type."));
					break;
				}

				wData = vo->toString();
                
                // Now API works with char data
                charData = wchar2char(wData);
				

				delete   vo;  vo = NULL;
                if (wData != NULL){
                    delete wData; wData = NULL;
                }
			}

			
			// Here we set data of the current item (char content).
            if (charData != NULL){
                syncItem->setData(charData, strlen(charData));

                delete [] charData;   charData = NULL;
            }

            delete [] fileContent; fileContent = NULL;
		}


		
		// Fill the proper array with this syncItem.
		if (wcscmp(typeOfArray, ALL) == 0)
			c->addItemToAllItems(syncItem);

		else if (wcscmp(typeOfArray, NEW) == 0)
			c->addItemToNewItems(syncItem);

		else if (wcscmp(typeOfArray, MOD) == 0)
			c->addItemToUpdatedItems(syncItem);

		//else if (wcscmp(typeOfArray,DEL) == 0)		// No del items here (see 'getDelItemsFromString' function)
		//	c->addItemToDeletedItems(syncItem);

        if (syncItem) {
            delete syncItem;   syncItem = NULL;
        }
    }
    LOG.debug(T("Exit method fillItemsArrayFromFileSystem"));
}



/*
 * Get ALL items from an xml string, fill the allItems array of the container 'c'.
 * The xml string contains only the key for each item (for refresh-from-server sync).
 *
 * @param c   : the container with arrays to fill
 * @param xml : the xml string containing keys of items (on client)
 * @return    : number of all items added
 */
int getAllItemsKeyFromString (Container* c, wchar_t* xml) {

	SyncItem* syncItem = NULL;
	wchar_t localTemp[DIM_LOCAL_TEMP];
	wchar_t* numItems = NULL;
    wchar_t* tmp = NULL;
    wchar_t* id = NULL;
	int i = 0;
    unsigned int tmpPos, pos = 0;

    LOG.debug(T("Enter method getAllItemsKeyFromString"));

    // Get number of items.
    numItems = getElementContent(xml, TEXT("numItems"), &pos);

    if (numItems == NULL) {
        if (dbg) {
            wsprintf(localTemp, TEXT("getAllItemsKeyFromString: numero di items %s"), numItems);
            MessageBox (NULL, localTemp, TEXT ("keyXml"), MB_SETFOREGROUND |MB_OK);
        }
        LOG.debug(T("Exit method getAllItemsKeyFromString: element numItems is NULL"));
        return 0;
    }

    int l = wcstol(numItems, &tmp, 0);

    if (dbg) {
        wsprintf(localTemp, TEXT("getAllItemsKeyFromString: numero di items %i"), l);
        MessageBox (NULL, localTemp, TEXT ("keyXml"), MB_SETFOREGROUND |MB_OK);
        wsprintf(localTemp, TEXT("lunghezza xml: %i"), wcslen(xml));
        MessageBox (NULL, localTemp, TEXT ("keyXml"), MB_SETFOREGROUND |MB_OK);
        LOG.debug(T("%ls"), xml);
        MessageBox (NULL, xml, TEXT ("keyXml"), MB_SETFOREGROUND |MB_OK);
    }


	// Cicle: search for Item keys.
    for (i = 0; i < l; i++) {
        tmpPos = 0;
        
		// Get the 'id' of the current item.
		id = getElementContent(&xml[pos], TEXT("identifier"), &tmpPos);
        pos = tmpPos + pos;
		
        // Insert the current item into the container (only key is saved).
		syncItem = new SyncItem(id);
		c->addItemToAllItems(syncItem);
        delete syncItem; syncItem = NULL;
    }


	// Free mem.
    if (numItems != NULL){
		delete [] numItems; numItems = NULL;
    }
    if (id != NULL){
		delete [] id; id = NULL;
    }

    LOG.debug(T("Exit Method getAllItemsKeyFromString"));

    return l;
}






//------------------------- From Server to Client functions -----------------------------
/*
 * From server to client outlook. Creates an xml SIF string for a single NEW ITEM.
 * Note: The return value is a new wchar_t* and must be freed by the caller
 *
 * @param item       : the new item to add
 * @param sourceName : the source to sync (contact | calendar | task | note)
 * @return           : the xml SIF builded for this item 
 */
wchar_t* manageNewItem(SyncItem* item, const wchar_t* sourceName) {

    LOG.debug(T("Enter Method manageNewItem."));
    char*    ptrData = NULL;
	wchar_t* wptrData = NULL;
	string newString = string();
	int len;

    if (item->getDataSize() == 0)
        return NULL;
	
    bool isSIF = checkSIF(sourceName);
	
    // Data content is char* -> need to decode from UTF-8 before appending to string.
    ptrData = stringdup((char*)item->getData(), item->getDataSize());
    wptrData = char2wchar(ptrData);


    // Build the xml string.
    newString = TEXT("");
    newString = newString + TEXT("<NEW>");
    newString = newString + TEXT("<numItems>1</numItems>");         // Note: Only 1 single Item.
    newString = newString + TEXT("<row>");
    newString = newString + TEXT("<identifier>") + item->getKey();
    newString = newString + TEXT("</identifier>");
    newString = newString + TEXT("<bodyMsgValue>");

	//
	// VB actually needs XML SIF to insert the current item 
	// into outlook. Source 'notes' is always in SIF format.
	//
	// ------------ SIF format --------------
	// (passing SIF XML directly to VB)
	if(isSIF || wcscmp(NOTES, sourceName) == 0){
		newString = newString + wptrData;
		replaceAmpLGt(newString);
	}

	// ----------- Vcard - Ical -------------
	// (Vcard XML -> VObject -> SIF XML)
	else{
		string SIFString = string();
		VObject* vo = VConverter::parse(wptrData);
		
		if(vo) {
			if (wcscmp(CONTACTS, sourceName) == 0)				// contact
				VObjectContact2SIF(SIFString, vo);

			else if (wcscmp(APPOINTMENTS, sourceName) == 0) 	// calendar
				VObjectAppointment2SIF(SIFString, vo);

			else if (wcscmp(TASKS, sourceName) == 0) 			// tasks
				VObjectTask2SIF(SIFString, vo);

			else{
				LOG.debug(T("Error converting Vcard to SIF: unknown folder type."));
				SIFString = TEXT("");
			}
			delete vo; vo = NULL;
		}
		if (SIFString != TEXT(""))
			newString = newString + SIFString;
	}


    newString = newString + TEXT("</bodyMsgValue>");
    newString = newString + TEXT("</row>");
    newString = newString + TEXT("</NEW>");

    //Alloc mem for the Xml string to return.
    len = length(newString);
    wchar_t* retXml = new wchar_t[len+1];
    wcscpy(retXml, (wchar_t*)newString);

    // Free mem
    if (ptrData){
        delete [] ptrData;   ptrData = NULL;
    }
	if (wptrData != NULL){
		delete [] wptrData; wptrData = NULL;
	}

    LOG.debug(T("Exit Method manageNewItem."));
    return retXml;
}


/*
 * From server to client outlook. Creates an xml SIF string for an single UPDATED ITEM.
 * Note: The return value is a new wchar_t* and must be freed by the caller
 *
 * @param item       : the updated item
 * @param sourceName : the source to sync (contact | calendar | task | note)
 * @return           : the xml SIF builded for this item
 */
wchar_t* manageUpdatedItem(SyncItem* item, const wchar_t* sourceName) {

    LOG.debug(T("Enter Method manageUpdatedItem."));
    char*    ptrData = NULL;
	wchar_t* wptrData = NULL;
	string modString = string();
    int len;
	
    if (item->getDataSize() == 0)
        return NULL;

    bool isSIF = checkSIF(sourceName);
	
    // Data content is char* -> need to decode from UTF-8 before appending to string.
    ptrData = stringdup((char*)item->getData(), item->getDataSize());
    wptrData = char2wchar(ptrData);


    // Build the xml string.
    modString = TEXT("");
    modString = modString + TEXT("<MOD>");
    modString = modString + TEXT("<numItems>1</numItems>");         // Note: Only 1 single Item.
    modString = modString + TEXT("<row>");
    modString = modString + TEXT("<identifier>") + item->getKey();
    modString = modString + TEXT("</identifier>");
    modString = modString + TEXT("<bodyMsgValue>");

	//
	// VB actually needs XML SIF to insert the current item 
	// into outlook. Source 'notes' is always in SIF format.
	//
	// ------------ SIF format --------------
	// (passing SIF XML directly to VB)
	if(isSIF || wcscmp(NOTES, sourceName) == 0){
		modString = modString + wptrData;
		replaceAmpLGt(modString);
	}

	// ----------- Vcard - Ical -------------
	// (Vcard XML -> VObject -> SIF XML)
	else{
		string SIFString = string();
		VObject* vo = VConverter::parse(wptrData);
		
		if(vo) {
			if (wcscmp(CONTACTS, sourceName) == 0)		        // contact
				VObjectContact2SIF(SIFString, vo);

			else if (wcscmp(APPOINTMENTS, sourceName) == 0) 	// calendar
				VObjectAppointment2SIF(SIFString, vo);

			else if (wcscmp(TASKS, sourceName) == 0) 	        // tasks
				VObjectTask2SIF(SIFString, vo);

			else{
				LOG.debug(T("Error converting Vcard-Ical to SIF: unknown folder type."));
				SIFString = TEXT("");
			}
			delete vo; vo = NULL;
		}
		if (SIFString != TEXT(""))
			modString = modString + SIFString;
	}

    modString = modString + TEXT("</bodyMsgValue>");
    modString = modString + TEXT("</row>");
    modString = modString + TEXT("</MOD>");
    
    //Alloc mem for the Xml string to return.
    len = length(modString);
    wchar_t* retXml = new wchar_t[len+1];

    wcscpy(retXml, (wchar_t*)modString);
    
    // Free mem
    if (ptrData){
        delete [] ptrData; ptrData = NULL;
    }
	if (wptrData != NULL){
		delete [] wptrData; wptrData = NULL;
	}

    LOG.debug(T("Exit Method manageUpdatedItem."));
    return retXml;
}


/*
 * From server to client outlook. Creates an xml string for a single DELETED ITEM.
 * 
 * @param item     : the deleted item
 * @return         : the xml builded for this item
 */
wchar_t* manageDeletedItem(SyncItem* item) {

    LOG.debug(T("Enter Method manageDeletedItem."));
	string delString = string();
    int len;

    // Build the xml string.
    delString = TEXT("");
    delString = delString + TEXT("<DEL>");
    delString = delString + TEXT("<numItems>1</numItems>");         // Note: Only 1 single Item.
    delString = delString + TEXT("<row>");
    delString = delString + TEXT("<identifier>") + item->getKey();
    delString = delString + TEXT("</identifier>");
    delString = delString + TEXT("</row>");
    delString = delString + TEXT("</DEL>");

    //Alloc mem for the Xml string to return.
    len = length(delString);
    wchar_t* retXml = new wchar_t[len+1];

    wcscpy(retXml, (wchar_t*)delString);

    LOG.debug(T("Exit Method manageDeletedItem."));
    return retXml;
}



/* ====================================================================================== 
 *                                  LOG Functions
 * ====================================================================================== 
 */

// Init Log file. 
// Set log path, set log name, reset and set log level read from Config.
// Also set the userAgent as the programName (including version)
DWORD WINAPI openLog(LPCSTR pathVB, LPCSTR nameVB) {

    char value[MAX_KEY_LENGTH];
    value[0] = 0;

    OutlookConfig oc = OutlookConfig();
    oc.getPropertyValue(T(""), PROPERTY_LOG_LEVEL, value);

    Log(0, (char*)pathVB, LOG_NAME);
	LOG.reset(LOG_TITLE);

    if (strcmp(value, T("0")) == 0) {
        LOG.setLevel(LOG_LEVEL_NONE);
    } else if (strcmp(value, T("2")) == 0) {
        LOG.setLevel(LOG_LEVEL_DEBUG);
    } else { // default info
        LOG.setLevel(LOG_LEVEL_INFO);
    }

	wchar_t* wName = toWideChar(nameVB);
	wcscpy(programName, wName);
	delete [] wName;

	return 0;
}


void WINAPI printLog (LPCSTR log, LPCSTR level) {

    if (strcmp(level, DEBUG_LEVEL) == 0)
        LOG.debug("%s", log);
    else if (strcmp(level, INFO_LEVEL) == 0)
        LOG.info("%s", log);
    else if (strcmp(level, ERROR_LEVEL) == 0)
        LOG.error("%s", log);

}




/* ======================================================================================  
 * Entry point to start the synchronization process, specifying which
 * source to synchronize.
 *
 * @param folderType : the OL folder type referred to the source to synchronize (9 | 10 | 12 | 13)
 * @param pathVB     : the path where files are stored
 * @return           : 0 if no errors
 * ======================================================================================
 */
DWORD WINAPI synchronization (LPCSTR folderType, LPCSTR pathVB) {

    LOG.debug(T("Enter function synchronization..."));
 
    // Convertions to wchar_t.
    wchar_t path[DIM_LOCAL_TEMP];
    int l = strlen(pathVB);
    MultiByteToWideChar (CP_ACP, 0, pathVB, l, path, l);
    path[l] = 0;

    wchar_t wfolderType[DIM_LOCAL_TEMP];
    l = strlen(folderType);
    MultiByteToWideChar (CP_ACP, 0, folderType, l, wfolderType, l);
    wfolderType[l] = 0;

    int ret = 0; 
    SyncSource** ssArray;
	wchar_t sourceName[10];
    
    // Select the source to sync                      
    if (wcscmp(wfolderType, OL_FOLDER_CONTACTS) == 0){              // CONTACTS  
        wcscpy(sourceName, CONTACTS);	
    }                                                           
    else if (wcscmp(wfolderType, OL_FOLDER_APPOINTMENTS) == 0){     // APPOINTMENTS
        wcscpy(sourceName, APPOINTMENTS);
    }                                                     
    else if (wcscmp(wfolderType, OL_FOLDER_TASKS) == 0){            // TASKS
		wcscpy(sourceName, TASKS);
    }                                                    
    else if (wcscmp(wfolderType, OL_FOLDER_NOTES) == 0){            // NOTES
		wcscpy(sourceName, NOTES);
    }
    else{
        LOG.error(T("Error: folderType not recognized."));
        return -1;
    }

	// 
	// Create a new SyncSource (only 1 source to sync)
	// 
	WindowsSyncSource s = WindowsSyncSource(sourceName);
    s.setPath(path);
	s.setType(wfolderType);
    
	ssArray = new SyncSource*[2];
    ssArray[0] = &s;
    ssArray[1] = NULL;


    //
    // Now we can create the Sync4jClient object and kick off the sync
    //
    Sync4jClient& s4j = Sync4jClient::getInstance();
    s4j.setDMConfig(APPLICATION_URI);
    
    ret = s4j.sync(ssArray);

    Sync4jClient::dispose();
    
    if (ssArray != NULL){
        delete [] ssArray; ssArray = NULL;
    }


    #ifdef MALLOC_DEBUG
        //char* provaLeak = new char[10000000];
        printMemLeaks();
    #endif

    return ret;
}



/*
 * ====================================================================================== 
 *                          CONFIGURATION Access Functions
 * ====================================================================================== 
 * 
 * Functions called by Outlook Client (VB) to access the config parameters
 * stored in win registry. We use the OutlookConfig class to access the DMTree.
 * Note:
 *      API Device Managment (DM) is based on char strings, also OutlookConfig class 
 *      is based on char strings.
*/


/* Get a generic property value for Outlook Client (read in win registry).
 * @param context : the relative path in win registry under funambol application node.
*/
DWORD WINAPI getRegProperty (LPCSTR context, LPCSTR propertyName, LPSTR propertyValue, LONG propValueSize) {

    char* internalBuffer = new char[MAX_KEY_LENGTH];
	
	OutlookConfig oc = OutlookConfig();
    int ret = oc.getPropertyValue(context, propertyName, internalBuffer);

	unsigned long size = propValueSize;

    if (size > strlen(internalBuffer)) {
        strcpy(propertyValue, internalBuffer);
        propertyValue[strlen(propertyValue)] = ' ';
    }

	delete [] internalBuffer;

    return ret;
}

/* Set a generic property value for Outlook Client (write in win registry).
 * @param context : the relative path in win registry under funambol application node.
*/
DWORD WINAPI setRegProperty (LPCSTR context, LPCSTR propertyName, LPCSTR propertyValue) {

    OutlookConfig oc = OutlookConfig();
    int ret = oc.setPropertyValue(context, propertyName, propertyValue);

    return ret;
}


/* Get a configuration property value for Outlook Client (read in win registry).
 * @param spdmName : the definition name of property according to Outlook client.
*/
DWORD WINAPI getRegConfigProperty (LPCSTR spdmName, LPSTR propertyValue, LONG propValueSize) {

	char* internalBuffer = new char[MAX_KEY_LENGTH];

    OutlookConfig oc = OutlookConfig();
    int ret = oc.getConfigPropertyValue(spdmName, internalBuffer);

	unsigned long size = propValueSize;

    if (size > strlen(internalBuffer)) {
		strcpy(propertyValue, internalBuffer);
		propertyValue[strlen(propertyValue)] = ' ';
    }

	delete [] internalBuffer;

    return ret;
}

/* Set a configuration property value for Outlook Client (write in win registry).
 * @param spdmName : the definition name of property according to Outlook client.
*/
DWORD WINAPI setRegConfigProperty (LPCSTR spdmName, LPCSTR propertyValue){
 
	OutlookConfig oc = OutlookConfig();
    int ret = oc.setConfigPropertyValue(spdmName, propertyValue);

	return ret;
}


/* Get a syncsource property value for Outlook Client (read in win registry).
 * @param sourceName   : the definition name of syncsource according to Outlook client.
 * @param propertyName : the exact name corresponding to the win registry property.
*/
DWORD WINAPI getRegSourceProperty (LPCSTR sourceName, LPCSTR propertyName, LPSTR propertyValue, LONG propValueSize) {

	char* internalBuffer = new char[MAX_KEY_LENGTH];

    OutlookConfig oc = OutlookConfig();
	int ret = oc.getSourcePropertyValue(sourceName, propertyName, internalBuffer);

	unsigned long size = propValueSize;

    if (size > strlen(internalBuffer)) {
        strcpy(propertyValue, internalBuffer);
        propertyValue[strlen(propertyValue)] = ' ';
    }

	delete [] internalBuffer;

    return ret;
}

/* Set a syncsource property value for Outlook Client (write in win registry).
 * @param sourceName   : the definition name of syncsource according to Outlook client.
 * @param propertyName : the exact name corresponding to the win registry property.
*/
DWORD WINAPI setRegSourceProperty (LPCSTR sourceName, LPCSTR propertyName, LPCSTR propertyValue) {

	OutlookConfig oc = OutlookConfig();
	int ret = oc.setSourcePropertyValue(sourceName, propertyName, propertyValue);

    return ret;
}



/*
 * Get all communications settings for Outlook Client.
 * It's used to get multiple properties that are often requested together 
 * with one single call.
*/
DWORD WINAPI getCommunicationSettings (LPSTR syncURL, LPSTR serverName, LPSTR username, LPSTR password, LPSTR deviceId, LONG propValueSize) {
 
    int ret = 0;
	char* internalBuffer = new char[MAX_KEY_LENGTH];
	unsigned long size = propValueSize;
	
	OutlookConfig oc = OutlookConfig();

	// get syncURL
    ret = oc.getConfigPropertyValue(SPDM_SYNCURL, internalBuffer);
	if (ret != 0) goto finally;
    if (size > strlen(internalBuffer)) {
        strcpy(syncURL, internalBuffer);
        syncURL[strlen(syncURL)] = ' ';
    }
	// get serverName
    ret = oc.getConfigPropertyValue(SPDM_SERVERNAME, internalBuffer);
	if (ret != 0) goto finally;
    if (size > strlen(internalBuffer)) {
        strcpy(serverName, internalBuffer);
        serverName[strlen(serverName)] = ' ';
    }
	// get username
	ret = oc.getConfigPropertyValue(SPDM_USERNAME, internalBuffer);
	if (ret != 0) goto finally;
    if (size > strlen(internalBuffer)) {
        strcpy(username, internalBuffer);
        username[strlen(username)] = ' ';
    }
	// get password
    ret = oc.getConfigPropertyValue(SPDM_PASSWORD, internalBuffer);
	if (ret != 0) goto finally;
    if (size > strlen(internalBuffer)) {
        strcpy(password, internalBuffer);
        password[strlen(password)] = ' ';
    }
	// get deviceId
    ret = oc.getConfigPropertyValue(SPDM_DEVICEID, internalBuffer);
	if (ret != 0) goto finally;
    if (size > strlen(internalBuffer)) {
        strcpy(deviceId, internalBuffer);
        deviceId[strlen(deviceId)] = ' ';
    }

finally:

	delete [] internalBuffer;
    return ret;
}

/*
 * Set all communications settings for Outlook Client.
 * It's used to set multiple properties that are often stored together 
 * with one single call.
*/
DWORD WINAPI setCommunicationSettings (LPCSTR syncURL, LPCSTR serverName, LPCSTR username, LPCSTR password, LPCSTR deviceId) {

    int ret = 0;
	OutlookConfig oc = OutlookConfig();

	// set syncURL
    ret = oc.setConfigPropertyValue(SPDM_SYNCURL, syncURL);
	if (ret != 0) goto finally;
	// set serverName
    ret = oc.setConfigPropertyValue(SPDM_SERVERNAME, serverName);
	if (ret != 0) goto finally;
	// set username
    ret = oc.setConfigPropertyValue(SPDM_PASSWORD, password);
	if (ret != 0) goto finally;
	// set password
    ret = oc.setConfigPropertyValue(SPDM_USERNAME, username);
	if (ret != 0) goto finally;
	// set deviceId
    ret = oc.setConfigPropertyValue(SPDM_DEVICEID, deviceId);
	if (ret != 0) goto finally;

finally:

    return ret;
}
// ==============================================================================


DWORD WINAPI getDayLight () {

    TIME_ZONE_INFORMATION tmz;

    GetTimeZoneInformation(&tmz);
    long ret = 0;
    ret = tmz.DaylightBias;

    if (ret = -60)
        ret = 1;

    return ret;
}

DWORD WINAPI isAnotherWindow() {
    HWND hwnd = FindWindow(NULL, TEXT("SyncClient Outlook"));
    if (hwnd != NULL) {
        SetForegroundWindow(hwnd);
        CloseHandle(hwnd);
        return 1;
    }
    return 0;
}
