/*
 * Copyright (C) 2003-2006 Funambol
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef INCL_UTILS_OL
    #define INCL_UTILS_OL
    

    #include "base/fscapi.h"

	#include "ptypes/ptypes.h"
    #include "spdm/spdmutils.h"

	#include "vocl/VObject.h"
	#include "vocl/VConverter.h"

	#include "outlook/AppointmentBuilder.h"
	#include "outlook/ContactBuilder.h"
	#include "outlook/TaskBuilder.h"
	#include "base/quoted-printable.h"

	USING_PTYPES


	#define QP_MAX_LINE_LEN 70


    /*-----------utils functions -----------------*/
	wchar_t* getElementContent(wchar_t* xml, wchar_t* tag, unsigned int* pos);
	
	// To remove! (see toWideChar() and toMultibyte() in win32adapter)
	char* wchar2char(wchar_t* wtoken);
	wchar_t* char2wchar(char *token);
    ////////////

	wchar_t* decodeBase64W(wchar_t* toDecode);
	wchar_t* decodeBase64WUTF8(wchar_t* toDecode);
	wchar_t* encodeBase64UTF8(char* toEncode);
	wchar_t* encodeBase64W(wchar_t* toEncode);

	void encodeSpecialChar(string &s);
	void encodeSpecialChar2XML(string &s);
	void replaceAmpLGt(string &s);

	void UTCToLocalTime(SYSTEMTIME &sysTime);
	void localTimeToUTC(SYSTEMTIME &sysTime);
	BOOL getDateAndTimeAsIs(wchar_t* dataString, DATE* date);

	void systemTimeToDouble(wchar_t* dataString, DATE* date, wchar_t* action);
    void systemTimeToDoubleBirthday(wchar_t* dataString, DATE* date);
    void systemTimeToDoubleBirthFormat(wchar_t* dataString, DATE* date, wchar_t* type);
	void doubleToSystemTime(wchar_t* tempDate, DATE date); 
	void doubleToSystemTimeHourZero(wchar_t* tempDate, DATE date, BOOL isHourToSetToZero);
    void doubleToSystemTimeOnlyDate(wchar_t* tempDate, DATE date);
    void doubleToSystemTimeBirthday(wchar_t* tempDate, DATE date);

	bool     convertRruleToSIF(string &recurrenceString, wchar_t* rrule, DATE startDate);
	wchar_t* convertSIFToRrule(wchar_t* ptrData);
	wchar_t* extractDayOfWeek(long l);
	long     calculateDayOfWeek(wchar_t* in);
	bool     isDayOfWeek(wchar_t* string);
	long     getWeekDay(DATE  dt);

	void writeTheFile(wchar_t* path, wchar_t* content);
	wchar_t* readContentFromFile(wchar_t* path);

	bool checkSIF(const wchar_t* wsourceName);

#endif